#include <stdlib.mqh>


extern int signal_bar    = 1;
extern int NO_Trades  = 3;

extern int silver_RISK=3;
extern int silver_CountBars=350;

extern int    atr_Length=10;
extern int    ATRperiod=5;
extern double Kv=2.5;

extern double lot_size  = 0.1;
extern int net_profit  = 20;
extern int net_loss    = 5000;

extern int MAGIC_NUM  = 647329200;
extern int Slippage = 4;
extern int num_of_try = 5;

int current_id = 0;
/*
bool is_history(string ID){
   datetime ctime = Time[0];
   datetime max_range = 72 * 3600;
   for(int i=HistoryTotal()-1;i>=0;i--){
      if(
         OrderSelect(i,SELECT_BY_POS, MODE_HISTORY)==true && 
         OrderMagicNumber() && MAGIC_NUM == MAGIC_NUM && 
         OrderSymbol()==Symbol() &&
         OrderComment()==ID
         ){
         datetime t = ctime - OrderCloseTime();
         if(t>max_range) return (false);
         return (true);
         }
      }
   return (false);
}
*/
int get_position_by_id(string ID,int &ticket[]){
   int fpos = 0;
   for(int i=OrdersTotal()-1;fpos<2 && i>=0;i--){
      if(
         OrderSelect(i,SELECT_BY_POS, MODE_TRADES)==true && 
         OrderMagicNumber() && MAGIC_NUM == MAGIC_NUM && 
         OrderComment()==ID
         ){
         ticket[fpos]=OrderTicket();
         fpos++;
         }
      }
   return (fpos);
}

bool close_if_needed(int &ticket[]){
   double prof = 0;
   bool close = false;
   for(int i=0;!close && i<2;i++){
      if(OrderSelect(ticket[i],SELECT_BY_TICKET, MODE_TRADES)){
         Print(ticket[i]+" = "+OrderProfit());
         prof += OrderProfit();
         }
      else{
         close = true;
         }
      }
   if(!close && (prof>=net_profit || MathAbs(prof)>=net_loss)) close = true;
   return (close);
}

datetime last_signal = 0;

void load_current_id(){
   current_id = 0;
   for(int i=OrdersTotal()-1;i>=0;i--){
      if(
         OrderSelect(i,SELECT_BY_POS, MODE_TRADES)==true && 
         OrderMagicNumber() && MAGIC_NUM == MAGIC_NUM && 
         OrderSymbol()==Symbol() 
         ){
          int tid = StrToInteger(OrderComment());
          if(tid>current_id){
            current_id = tid;
            last_signal = OrderOpenTime();
            }
          }
      }
}

//+------------------------------------------------------------------+
int find_all_order(){
   int n = 0;
   for(int i=OrdersTotal()-1;i>=0;i--){
      if(
         OrderSelect(i,SELECT_BY_POS, MODE_TRADES)==true && 
         OrderMagicNumber() && MAGIC_NUM == MAGIC_NUM && 
         OrderSymbol()==Symbol() 
         ){
            n++;
          }
      }
   return (n);
}


int last = 0;
double ltime = 0;

void place_order(){
   load_current_id();
   int lb = iBarShift(NULL,0,last_signal);
   // don't open trade twice
   if((last_signal==0 || lb!=0)&& find_all_order() < NO_Trades){
      // get signal
      double silver = iCustom("GBPUSD",0,"SilverTrend_Signal",silver_RISK,silver_CountBars,0,signal_bar);
      if(silver==0) silver = -iCustom("GBPUSD",0,"SilverTrend_Signal",silver_RISK,silver_CountBars,1,signal_bar);

      double atr_stop = iCustom("GBPUSD",0,"ATRStops_v1[1].1",atr_Length,ATRperiod,Kv,0,signal_bar);
      if(atr_stop==EMPTY_VALUE){ 
         atr_stop = iCustom("GBPUSD",0,"ATRStops_v1[1].1",atr_Length,ATRperiod,Kv,1,signal_bar);
         if(atr_stop==EMPTY_VALUE){
            return (0);
            }
         else{
            if(silver>=0) return (0);
            }
         }
      else{
         if(silver<=0) return (0);
         }
      
      if(silver!=0){
            current_id++;
            // open new position
            if(silver>0){
               open_position("GBPUSD",true);
               open_position("EURUSD",false);
               }
            else{
               open_position("GBPUSD",false);
               open_position("EURUSD",true);
               }
         }
      }
   int ticket[2] = {0};
   for(int i=OrdersTotal()-1;i>=0;i--){
      if(
         OrderSelect(i,SELECT_BY_POS, MODE_TRADES) && 
         OrderMagicNumber() && MAGIC_NUM == MAGIC_NUM && 
         OrderSymbol()==Symbol() 
         ){
          get_position_by_id(OrderComment(),ticket);
          if(close_if_needed(ticket)){
            close_trade(ticket[0]);
            close_trade(ticket[1]);
            }
          }
      }
   
}

int start(){
//---- 
   place_order();
//----
   return(0);
}
  
double params[4];
bool open_position(string cur,bool buy){
   RefreshRates();
   int d = MarketInfo(cur,MODE_DIGITS);
   double p  = MarketInfo(cur,MODE_POINT);
   int ticket;
   
   if(buy){
      // BUY
      params[0] = NormalizeDouble(MarketInfo(cur,MODE_ASK),d);
      params[1] = NormalizeDouble(0,d);
      params[2] = NormalizeDouble(0,d);
         
      ticket = execute_order(cur,OP_BUY,Aqua,num_of_try,1,0);
      return(OrderSelect(ticket,SELECT_BY_TICKET,MODE_TRADES));
      }
   else{
      params[0] = NormalizeDouble(MarketInfo(cur,MODE_BID),d);
      params[1] = NormalizeDouble(0,d);
      params[2] = NormalizeDouble(0,d);
         
      ticket = execute_order(cur,OP_SELL,Yellow,num_of_try,1,0);
      return (OrderSelect(ticket,SELECT_BY_TICKET,MODE_TRADES));
      }
   return (false);
}

int execute_order(string cur,int otype,color c,int try_num,int multi,double op){
   int ticket = -1;
   double price;

   string comment = current_id;
   int error=0;
   while(IsTradeAllowed() && try_num>=0 && ticket<0){
      try_num--;
      
      if(otype==OP_BUY)       ticket=OrderSend(cur,otype ,lot_size*multi,MarketInfo(cur,MODE_ASK),Slippage,params[2],params[1],comment,MAGIC_NUM,0,c);
      else if(otype==OP_SELL) ticket=OrderSend(cur,otype ,lot_size*multi,MarketInfo(cur,MODE_BID),Slippage,params[2],params[1],comment,MAGIC_NUM,0,c);
      else{
         ticket=OrderSend(cur,otype ,lot_size*multi,params[0],Slippage,params[2],params[1],comment,MAGIC_NUM,0,c);
         }
         
      if(ticket<=0){
         error=GetLastError();
         
         if(error==134) break;            // not enough money
         if(error==135) RefreshRates();   // prices have changed
         //break;
         }
      }

   return (ticket);
}


int init(){
   return(0);
}

int deinit(){
   return(0);
}

void close_trade(int ticket){
   if(ticket!=0 && OrderSelect(ticket,SELECT_BY_TICKET, MODE_TRADES)){
      if(OrderType()==OP_BUY){
         while(OrderClose(ticket,OrderLots(),MarketInfo(OrderSymbol(),MODE_BID),Slippage,Crimson)==false){
            Sleep(1000);
            if(OrderSelect(ticket,SELECT_BY_TICKET, MODE_TRADES)==false || OrderMagicNumber() && MAGIC_NUM != MAGIC_NUM) break;
            }
         }
      else if(OrderType()==OP_SELL){
         while(OrderClose(ticket,OrderLots(),MarketInfo(OrderSymbol(),MODE_ASK),Slippage,Crimson)==false){
            Sleep(1000);
            if(OrderSelect(ticket,SELECT_BY_TICKET, MODE_TRADES)==false || OrderMagicNumber() && MAGIC_NUM != MAGIC_NUM) break;
            }
         }
      }
}